
var quick_calls = 0;
var quick_hits = 0;

function quicksort(array) {
	var res = quicksort_rec(array, 0, array.length-1);
//	debugStr(res);
	return res;
}

function quicksort_rec(array, left, right) {
	quick_calls++;
	if(left < right) {
		var divider = divide(array, left, right);
		quicksort_rec(array, left, divider-1);
		quicksort_rec(array, divider+1, right);
	}
	return array;
}

function divide(array, left, right) {
	var i = left;
	var j = right;
	var pivot = array[left + Math.ceil((right-left) / 2)];//array[left + Math.floor((right-left)/2)];
//	quick_hits++;
	do {
		while(array[i] <= pivot && i < right) { i++;  }
		while(array[j] >= pivot && j > left)  { j--;  }
		if(i < j) { swap(array, i, j); quick_hits += 2; }
	} while(i < j);
	
	if(array[i] > pivot) {
//		quick_divides++;
		swap(array, i, right);
		quick_hits += 2;
	}
	return i;
}

//alert("quick: " + quicksort([1,5,7,8,4,3,6,8,0]).join(" "));
